SystemOrganization addCategory: #'Conman-Core'!
SystemOrganization addCategory: #'Conman-Core-Tests'!

Object subclass: #CMEvent
	instanceVariableNames: 'description duration name participants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:21'!
add: aParticipant
	participants add: aParticipant.
	aParticipant myAddEvent: self! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description
	^ description! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description: anObject
	description := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration
	^ duration! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration: anObject
	duration := anObject! !

!CMEvent methodsFor: 'initialize-release' stamp: 'srh 5/23/2007 22:32'!
initialize
	participants := Set new! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name
	^ name! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
name: anObject
	name := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
participants
	^ participants! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:22'!
remove: aParticipant
	participants remove: aParticipant.
	aParticipant myRemoveEvent: self! !

Object subclass: #CMParticipant
	instanceVariableNames: 'bio name events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

CMParticipant class
	instanceVariableNames: 'events'!

CMParticipant class
	instanceVariableNames: 'events'!

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:23'!
attend: anEvent
	anEvent add: self! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio
	^ bio! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio: anObject
	bio := anObject! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 23:20'!
events
	^events! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:21'!
initialize
	events := Set new.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/23/2007 23:19'!
myAddEvent: anEvent
	events add: anEvent.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/24/2007 07:22'!
myRemoveEvent: anEvent
	events remove: anEvent! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:19'!
unattend: anEvent
	anEvent remove: self! !

Object subclass: #CMRoom
	instanceVariableNames: 'capacity description name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity
	^ capacity! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity: anObject
	capacity := anObject! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description
	^ description! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description: anObject
	description := anObject! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

TestCase subclass: #CMEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:18'!
testAdd
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	e add: p.
	self assert: e participants size = 1.
	self assert: (e participants asOrderedCollection at: 1) == p.
	self assert: p events size = 1.
	self assert: (p events asOrderedCollection at: 1) == e.! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:16'!
testRemove
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	e1 remove: p1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

TestCase subclass: #CMParticipantTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 06:58'!
testAttend
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	p attend: e.
	self assert: p events size = 1.
	self assert: (p events asOrderedCollection at: 1) == e.
	self assert: e participants size = 1.
	self assert: (e participants asOrderedCollection at: 1) == p.
! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:20'!
testUnattend
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	p1 unattend: e1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !
